// ------------------------------------------------------------
//  
//                                                 (c)NAV2 2005
// ------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>

#include <lcd_128x64.h>
#include <keys.h>
#include <bstack.h>
#include <menu.h>

#define LEVEL 7

BSTACK( s_pk, LEVEL );
BSTACK( s_of, LEVEL );

void* s_id[LEVEL];
unsigned char m_i; // 

void* cur_menu;

char m_pk; //    
char m_of; //    
 
MENU* m;

void init_stack(void)
{ 
   init_bstack( &s_pk );
   init_bstack( &s_of );
   m_i = 0;
}

void push_s_id(void* in)
{ s_id[m_i] = in; m_i = m_i + 1; }
void  *pop_s_id(void)
{ m_i = m_i - 1; return(s_id[m_i]); }

void PUSH(void)
{  // 
   bpush( &s_pk, m_pk );
   bpush( &s_of, m_of );
   push_s_id( m );
}

void POP(void)
{  // 
   m_pk = bpop( &s_pk );
   m_of = bpop( &s_of );
   m = pop_s_id();
}

// ------------------------------------
void init_menu(void)
{
   m_pk = 0;
   m_of = 0;
   init_stack();
}

unsigned int menu_exec(char vis)
{
  unsigned char i;
  unsigned char key;
  bit pr_exit;
  unsigned int c_node;
  char m_size;

   pr_exit = 0;
   c_node = 0;

   while(pr_exit == 0){
 
      i = 0;
      while(m[i].name != NULL){ i++; } //   
      m_size = i;

      i = 0;
      while((i<vis) && (m[i+m_of].name != NULL)){
         OutTextXY(0,i,m[i+m_of].name); 
         i++;
      }

      OutTextXY_i(0,m_pk,m[m_pk+m_of].name); //  ON
        key = ReadKeyW();
      OutTextXY(0,m_pk,m[m_pk+m_of].name);   //  OFF

  switch(key){
     case k_up:
            if(m_pk > 0){ m_pk--; }
			else{ if(m_of > 0){ m_of--; } }
     break; // -----------
     case k_down: 
            if((m_pk < vis-1)&&(m_pk < m_size-1)){ m_pk++; } // !!! -  !!!
			else{ if(m_of < (m_size-vis) ){ m_of++; } }
     break; // -----------
     case k_enter:
            if(m[m_pk+m_of].submenu == NULL){
              c_node = m[m_pk+m_of].id; //  
              pr_exit = 1;
            }
            else{  //   
              PUSH();
              m = m[m_pk+m_of].submenu;
			  //menu_init();
              m_pk = 0; m_of = 0;
            pr_exit = 1;
			}
     break; // -----------
     case k_esc:
	        if(m_i != 0){ POP(); }
			c_node = 0;
            pr_exit = 1;
     break; // -----------
    }
 } // while
  
 return(c_node);
}
